package org.act.echo.client;

import javax.xml.namespace.QName;
import javax.xml.rpc.Call;
import javax.xml.rpc.encoding.XMLType;
import javax.xml.rpc.ParameterMode;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceFactory;

public class TestEcho {
	
	private final static String SERVICE_FACTORY_PROPERTY = "javax.xml.rpc.ServiceFactory";

	private final static String SERVICE_FACTORY_IMPL_ACT = "org.act.soap.client.ServiceFactory";

	private final static String MESSAGE_FACTORY_PROPERTY = "javax.xml.soap.MessageFactory";

	private final static String MESSAGE_FACTORY_IMPL_ACT = "org.act.soap.message.MessageFactoryImpl";

	private final static String SOAP_CON_FACTORY_PROPERTY = "javax.xml.soap.SOAPConnectionFactory";

	private final static String SOAP_CON_FACTORY_IMPL_ACT = "org.act.soap.message.transport.ConnectionFactoryImpl";

	public static void main(String[] args) throws Exception {
		testEcho();
	}

	public static void testEcho() throws Exception {
		// setProperty of Factory
		System.setProperty(SERVICE_FACTORY_PROPERTY, SERVICE_FACTORY_IMPL_ACT);
		System.setProperty(MESSAGE_FACTORY_PROPERTY, MESSAGE_FACTORY_IMPL_ACT);
		System
				.setProperty(SOAP_CON_FACTORY_PROPERTY,
						SOAP_CON_FACTORY_IMPL_ACT);

		Service service = ServiceFactory.newInstance().createService(
				new QName(""));

		// construct a call object .
		Call call = service.createCall(new QName(""));
		call.setTargetEndpointAddress("http://localhost:8090/xlinker-2.4/Echo");
		call.setOperationName(new QName("echoString"));
		call.setReturnType(XMLType.XSD_STRING);
		call.addParameter("arg1", XMLType.XSD_STRING, ParameterMode.IN);
		String strRtn = (String) call.invoke(new Object[] { new String(
				"hello world!") });
		System.out.println("return String = " + strRtn);
	}
}
